
import { Position } from './position.js'

// TODO replace all instances of source, destination with 'Move' 
//          (everywhere, maybe not in the animation? less knowledge is more)

export class Move {
    constructor(source, destination) {
        this.source = source
        this.destination = destination
    }

    static fromSAN(move) {
        let source = null, destination = null

        if (move.length == 2) {
            destination = Position.from(move)
        }

        if (move.length == 4) {
            source = Position.from(move)
            destination = Position.from(move.substr(2))
        }

        // TODO validate distance (max 2 in both directions)

        return new Move(source, destination)
    }

    static isValid(move) {
        if (move.length != 2 || move.length != 4) {
            return false
        }

        // TODO use Position.isValid
        const sourceValid = move[0] >= 'a' && move[0] <= 'g' &&
            move[1] >= '1' && move[1] <= '8'

        if (sourceValid && move.length == 4) {
            return move[2] >= 'a' && move[2] <= 'g' &&
                move[3] >= '1' && move[3] <= '8'
        }

        return sourceValid
    }
}
