
import { htmlEncode } from './xss.js'

export class AutoPlay {

}

export class OutOfRangeException {
    constructor(message) {
        this.message = message
    }

    toString() {
        return this.message
    }
}

export class ListView {
    // TODO force an exception here by having less arguments and see if it bubbles up right and show the correct message
    constructor($table, $tbody, headers, moves, alignments) {       // TODO no moves knowledge!
        const $thead = $table.querySelector('thead')
        const $row = $thead.insertRow()
        for (const [index, header] of headers.entries()) {
            const $cell = document.createElement('th')
            $row.appendChild($cell)
            $cell.className = alignments[index]
            $cell.innerHTML = header
        }

        this.$tbody = $tbody
        $tbody.innerHTML = ''

        for (const [step, move] of moves.entries()) {
            const $row = $tbody.insertRow()
            $row.setAttribute('data-step', 1 + step)        // TODO data-step not needed, can be just the selectedrow index + 1

            // step
            let $cell = $row.insertCell()
            $cell.innerHTML = `${1 + step}.`

            // move
            $cell = $row.insertCell()
            $cell.innerHTML = `<a href="#${step}-${move}">${htmlEncode(move)}</a>`

            // stone count for players
            $cell = $row.insertCell()
            $cell.className = 'text-right'
            $cell = $row.insertCell()
            $cell.className = 'text-right'
        }
    }

    get selectedIndex() {
        const rows = [...this.$tbody.rows]
        const predicate = row => row.className == 'current'
        return rows.findIndex(predicate)
    }

    set selectedIndex(index) {
        if (index >= 0 && index < this.$tbody.rows.length) {
            for (const $row of this.$tbody.rows) {
                $row.className = ''
            }
            this.$tbody.rows[index].className = 'current'

            const options = {
                behavior: 'smooth',
                block: 'nearest',
                inline: 'start'
            }
            this.$tbody.rows[index].scrollIntoView(options)
        } else {
            throw new OutOfRangeException(index)
        }
    }
}
