import { FenLoader } from './fen.js'
import { PgnLoader } from './pgn.js'

class LoaderException {
    constructor(message) {
        this.message = message
    }

    toString() {
        return this.message
    }
}

export class Loaders {

    static getLoader(url) {
        // TODO streaming websocket support
        const extension = url.substr(url.lastIndexOf('.'))

        switch (extension) {
            case 'pgn': case '.pgn':
                return new PgnLoader()

            case 'fen': case '.fen':
                return new FenLoader()

            default:
                throw new LoaderException(`file type '${extension}' not supported`)
        }
    }

    // TODO validate that stone = COLOR! (for src, not dest -> hit)
    // TODO fen/pgn: validate all moves after loading (1 or 2 steps horz/vert/diag) 
    // TODO check if field empty field (fen/pgn)

    // TODO resolveAmbiguousMoves(() using a diff or possible moves set
    // get move for single moves like 'a2' (opposed to 'a3a2'))
    // Note there is some ambiguity in here because the stone can
    // come from multiple positions.
    // Secondary: maybe it is easier to scan the neighbours of the same color and
    // pick one at random. Warn that this was the case.
}
