export class SvgRenderer {

    constructor($root, size) {
        this.ns = 'http://www.w3.org/2000/svg'

        this.$root = $root
        this.size = size
        this.tileSize = 350 / size
    }

    renderBoard() {
        const svg = document.createElementNS(ns, 'svg')

        svg.setAttribute('width', size * 50)
        svg.setAttribute('height', size * 50)

        for (let row = 0; row < this.size; row++) {
            for (let column = 0; column < this.size; column++) {
                // tile
                const rect = document.createElementNS(this.ns, 'rect')
                rect.setAttribute('x', column * this.tileSize)
                rect.setAttribute('y', row * this.tileSize)
                rect.setAttribute('width', this.tileSize)
                rect.setAttribute('height', this.tileSize)
                rect.setAttribute('fill', row % 2 ^ column % 2 ? 'lightgray' : 'gray')
                svg.appendChild(rect)

                // piece
                const circle = document.createElementNS(this.ns, 'circle')
                rect.setAttribute('cx', column * this.tileSize)
                rect.setAttribute('cy', row * this.tileSize)
                rect.setAttribute('r', this.tileSiz * 2 / 3)
                rect.setAttribute('fill', row % 5 ^ column % 3 ? 'black' : 'white')
            }
        }
        this.$root.appendChild(svg)
    }
}
