const log = s => document.querySelector('pre').innerHTML += s + '\n'

// wss://server.ataxx.org/ws/viewer

const params = new URLSearchParams(document.location.search)
const url = params.get('url')
const ws = new WebSocket(url)
ws.addEventListener('open', e => {
    log('open')

    const params = new URLSearchParams(document.location.search)
    const [ player1, player2 ] = [ params.get('p1'), params.get('p2') ]

    ws.send(`${ player1 }|${ player2 }`)
})

ws.addEventListener('message', e => {
    console.log('message', { data: e.data })
    log(`message: ${e.data}`)

    const [type, player1, player2 ] = e.data.split(' ')
    if(type == 'new_pair') {
        console.log('new game', { player1, player2 })

        const href = `?url=${ url }&p1=${ encodeURIComponent(player1) }&p2=${ encodeURIComponent(player2) }`
        log(`<a href="${href}">${href}</a>`)
    }
})

ws.addEventListener('close', e => {
    console.log({ e })
    log(`${ e.code } ${ e.reason }`)
})

ws.addEventListener('error', e => {
    console.log({ e })
    log(e)
})
